package Sceptre;
use warnings;
use strict;
use Ayudas;
use Termicos;
use Ampliaciones;
use Data::Dumper;
use GlobalesSimusol;
use Tablasfuncq;
# ---------------------------------------------------------------------------
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw( $progname
                &separar_ls2
                &ac &transient_sol &post_processing &directory 
		&imprs_lis_obj_sceptre &imprs_archivo_mod
                &para_sceptre
       );  
};
END();
# ---------------------------------------------------------------------------
sub separar_ls2{
  comfin('com separar_ls2', @_);
  my $PROPIO = $_[0];
  -e "$PROPIO.ls2" or die "No existe el archivo $PROPIO.ls2";
  my @todo = `cat $PROPIO.ls2`; chomp @todo;
  my ($refvalores, $refvars) = ([],[]);
  my $ref = [];
  while (@todo) {
      my $renglon = shift @todo;
       if ($renglon =~ /^1/) {
          if ($renglon =~ /^1\s*TRANSIENT SOLUTION\s/) {
              transient_sol(\@todo, $refvalores);
 	  } elsif ($renglon =~ /^1\s*AC SOLUTION|AC\s/) {
              ac(\@todo,$refvalores); 
           } elsif ($renglon =~ /^1\s*(TRANSIENT ANALYSIS)\s/) {
	      until ($renglon =~ /^1/ or not @todo) { 
	          $renglon = shift @todo; push @$ref, $renglon;
	      };
          };
      } elsif ($renglon =~ /^0S C E P T R E/) {
           post_processing(\@todo, $refvalores, $refvars);
      } elsif ($renglon =~ /0 no. symbol_name/) {
           directory(\@todo, $refvalores);
       } else {
           push @$ref, $renglon;
       };
   };
  comfin('finS separar_ls2');
  return $refvalores, $refvars;   
}#separar_ls2 
#----------------------------------------------------------------------------
sub ac{
    comfin('comS ac', @_);
    my ($reftodo, $refvalores) = @_;
    until (/RUN\/RERUN NUMBER\D+(\d+)/ or not @$reftodo) {$_ = shift @$reftodo};
    # en lo anterior no queda asignado $1;
    my ($rerun) = /RUN\/RERUN NUMBER\D+(\d+)/;
    my $refval = $refvalores->[$rerun] = {};
    $_ = shift @$reftodo;
    until (/^0S C E P T R E\s*post/  or not @$reftodo) {
        if (/^\s*$/) { $_ = shift @$reftodo; next};
        my ($key,$value) = /^.(.{33})(.+)$/;
        $refval->{$key} = $value;
        $_ = shift @$reftodo;
    };
    unshift @$reftodo,$_;
   comfin('finS ac');
}
#----------------------------------------------------------------------------
sub transient_sol{
  comfin('comS transient_sol', @_);
  my ($reftodo, $refvalores) = @_;
  $_ = shift @$reftodo;
  my $rerun; my @vari;
  until (/^0S C E P T R E\s+post/ or not @$reftodo) {
      $_ = shift @$reftodo;
      if (/RUN\/RERUN NUMBER\D+(\d)+/) {
          $rerun = $1;
          my $refval = $refvalores->[$rerun] = {};
          $refval->{RERUN} = $rerun; 
	  $_ = shift @$reftodo;
                until ($_ !~ /^0/ and $_ !~ /^\s*$/) {
              if (/^0\s*$/ or /^\s*$/ or /^0___/){
                  $_ = shift @$reftodo;next
              };
              s/\s+$//;
              s/(OPTIONAL TERMINATION CODE IS)/$1      /;
	      my ($key,$value) = /^.(.{33})\s+(.+)$/;
	      $key =~ s/\s+$//;
              $refval->{$key} = $value;
              $_ = shift @$reftodo;
          };
          if (/INITIAL AND FINAL/) {
              $_ = shift @$reftodo;
              $_ = shift @$reftodo while /^\s*$/; 
              until (/^0/) {
                  my @lista = split /\s+/;
                  $refval->{$lista[1]}->[0] = $lista[2];
                  $refval->{$lista[1]} ->[1] = $lista[3];
                  push @vari, $lista[1];
	          $_ = shift @$reftodo;
              };
          };
      };
  };
  unshift @$reftodo,$_; 
  comfin('finS transient_sol');
} #transient_sol
#----------------------------------------------------------------------------
sub post_processing{
    comfin('comS post_processing', @_);
    my ($reftodo, $refvalores, $refvars) = @_;
    my $rerun = 0;
    while ($_ !~ /minimum * maximum/ and @$reftodo) {
        if (/RERUN\D+(\d+)/) {
            $rerun = $1;
        };
        $_= shift @$reftodo;
    };
    if (/minimum * maximum/) {
        if (not defined $refvalores->[$rerun]) {
	    $refvalores->[$rerun] = {};
	};
        my $refval = $refvalores->[$rerun];
	my $refvar = $refvars->[$rerun] = [];
        $_ = shift @$reftodo;
        $_ = shift @$reftodo;
        until (/^0/) {
           my @lista = split /\s+/;
           $refval->{$lista[2]}->[2] = $lista[-2];
           $refval->{$lista[2]} ->[3] = $lista[-1];
           push @$refvar, $lista[2];
           $_ = shift @$reftodo;
        };     
       /solution points[\D]*(\d+)/ and $refval->{puntos} = $1;  
    };
    unshift @$reftodo,$_;
    comfin('finS post_processing');
}#post_processing
#----------------------------------------------------------------------------
sub directory{
  comfin('comS directory', @_);
  my ($reftodo, $refvalores) = @_; 
  while (not /^\s+\d+\s*.......\d/) {$_ = shift @$reftodo;}
  unshift @$reftodo, $_;
  while (/^\s+(\d+)\s+(\S.....)(.)(\d+)/) {
      my ($num, $nombre, $tipo, $rerun) = ($1, $2, $3, $4);
      $nombre =~ s/(\w)\s*$/$1/;
      $refvalores->[$rerun]->{$nombre}->[4] = $num;
      $_ = shift @$reftodo;
  };
  unshift @$reftodo, $_;
  comfin('finS directory');
}#directory
# ----------------------------------------------------------------------------
sub para_sceptre{
  comfin('comS para_sceptre', @_);
  my ($ref,$valori,$tipo) = @_;#pueden llegar 'n' o 't' de un solo argumento simple
  $ref =~/HASH/ or error_progr(__FILE__,__LINE__, 'primer agumento no hash para para_sceptre');
  if (lc($tipo) eq 'n' and $valori) {
      $valori = sprintf("%6G", $valori);$valori =~ s/\s*//;
      if ($valori =~ /E/ and $valori !~ /\./) { 
          $valori =~ s/E/.E/;
      };
  } elsif ($tipo eq 'a') { 
      $valori eq 'TIEMPO' and $valori = 'TIME';
  } elsif ($valori =~ /^[CEIJLPRV]/) {
  } elsif ($valori =~ /^(\w+)\((.+)\)/) {
      my ($func,$dentro) = ($1, $2);
      $func =~ /^T/i or
         error_progr(0,__LINE__.' Scep '
		  ."LLega a para_septre $valori demasiado complicado");
      my $valoro;
      if ($dentro eq 'TIEMPO' or $dentro eq 'TIME') {
          $valoro = 'TIME'
      } else {
          my ($tipo,$valord) = tipear($ref,$dentro,0);
          $valoro = para_sceptre($ref,$valord,$tipo);
      };
      $valori = "$func($valoro)";   
  };
  comfin('finS para_sceptre', $valori);
  return $valori;
}#para_sceptre
# ----------------------------------------------------------------------------
sub sceptrear_expr{
  my $ref = $_[0]; my $numx = 1; 
  comfin('comS sceptrear_expr', @_);
  impr_datos(__LINE__.' Scep ',['INICIALES'],$ref);  
  #impr_obj(__LINE__.' Scep');
  #los identificadores de expresiones no pueden estar repetidos;
  #los repetidos quedan como XXX que luego se cambian
  foreach my $que ('PARAMETROS','DATOS','PARBORR') {
      # algunos parametros creados ya desaparecieron
      my @xkeys = grep(do{defined $ref->{"TIP$que"}->{$_} 
                          and $ref->{"TIP$que"}->{$_} eq 'x'}
		       ,@{$ref->{"lista$que"}});
      foreach my $key (@xkeys) {
          my $dato = $ref->{$que}->{$key};
          my ($identexpr,$resto) = ($dato =~ /^(X[^\(]*)\((.+)/);
          if (defined $identexpr  and defined $expr_usadas{$identexpr} 
              or length($identexpr) > 5  or length($identexpr) < 2) {
              $ref->{$que}->{$key} = "XXX($resto";
          } else {
              $expr_usadas{$identexpr} = 1;
	  };
      };
  };
  # aqui ya no hay problemas con signos de numeros; si 'q estan separados por '
  #     si 'x' todos los tokens numericos son no negativos
  #podria haber numeros precediendo parentesis como si fueran funciones
  foreach my $que ('PARAMETROS','DATOS','INICIALES','PARBORR') {
      foreach my $key (sort keys %{$ref->{$que}}) {
          my ($valor,$tipo,$tiparg,$refarg)
              = tomar_datos($ref,$que,$key ,__LINE__.' Scep sceptrear_expr');
          impr_dat(__LINE__.' Scep',$key,$ref,'sce'); 
          my $coment= '';
	  if ($valor =~ s/(;.+)$//) {$coment = $1};
          next if $tipo =~ /[p;I]/i;
          if ($tipo =~ /[aeijv]/i and $que ne 'INICIALES') {
              ($valor,$tipo,$tiparg,$refarg) =
		  ("XXX($valor)", 'x',lc($tipo),[$valor]);
             #se podria afinar mas pero no vale la pena  
          };
          if ($tipo =~ /[an\,]/i) {
	      $valor = para_sceptre($ref,$valor,$tipo);
          } elsif ($tipo eq 's') {
          } else {
              $valor =~ /^(\w+)\((.+)\)$/  or
                 error_progr($ref,__LINE__.' Scep '
                   . "tipo $tipo incompatible con $valor en sceptrear_expr");
              my $func = $1; my $dentro = $2;
              if ($dentro =~ /\W\d\w*\(/) {
		  parar1(66,$ref, __LINE__.
                   " Scep Falta simbolo de operación entre 
                      numero y paréntesis que abre en valor prara $key
                             $valor");
              };
              # si $tipo era 'a' quedaron indefinidos
              my @listip = split //,$tiparg;
              impr_debug(__LINE__.' Scep @listip',\@listip); 
              impr_dat_que($key,$que,__LINE__.' Scep ',$ref,'xx');
              if ($tipo =~ /[xf]/) {# en refarg hay tokens
                  impr_debug(__LINE__.' Scep $refarg',$refarg);
                  foreach my $tok (@$refarg) {
                      my $tipito = shift @listip; 
                      next if $tipito =~ /[pcefijlrvs]/;
                      if ($tipito =~ /[na]/) {
                          my $ntok = para_sceptre($ref,$tok,$tipito);
                          $valor =~ s/(\W)$tok(\W)/$1$ntok$2/;
                          $tok = $ntok;
                      } elsif ($tipito =~ /[tf]/) {
                      } elsif ($tipito eq 'q') {
                      } elsif ($tipito eq 'S') {
                          my $ntok = 'TIME';
                          $valor =~ s/(\W)$tok(\W)/$1$ntok$2/;
                          $tok = $ntok;  
                      } else {
    error_progr($ref,__LINE__.' Scep para '
     ."$que $key tipo de arg.  $tiparg ($tipito) incompatible con 
     $valor en sceptrear_expr");
                      };
                      #impr_debug(__LINE__.' Scep $valor ',$valor);
                  };
                  while ($valor
                       =~ s/(\W)(T\w+)\(([^\(\)]+)\)/$1XTABLE\($2,$3\)/) {};
                  $valor =~ s/\;$//;
                  if ($valor =~ /^XXX/) {
                      while ($expr_usadas{"X$numx"}) {$numx ++};
                      $valor =~ s/^XXX/X$numx/;
	              $numx++;
                  };
              } elsif ($tipo eq 't') {
                   error_progr($ref,"tabla $valor no con un argumento")
                       if @listip != 1; 
                   next if $tiparg =~/[fp]/; 
                   if ($tiparg =~ /[nat]/) { 
                      $dentro = para_sceptre($ref,$dentro,$tiparg);
                       $valor = "$func($dentro)";
                   } else { 
                       error_progr($ref
                          ,"$valor con $dentro de tipo $tiparg no esperado");
                   };
              } elsif ($tipo eq 'q') {
                   $tiparg =~ /[aeijnpv]*/i or
                   error_progr($ref,__LINE__.' Scep '.
                       "argumentos de tipos inesperados $tiparg en $dentro");
                   if ($tiparg =~ /[nat]/) {
                       $dentro = '';
                       for (my $i = 0; $i < @$refarg; $i ++) {
                            my $tipito = $listip[$i]; 
                            my $valori = $refarg->[$i];
                            impr_debug(__LINE__.' Scep $valori',$valori);   
                            if ($tipito =~ /[nat]/) {
		                 $valori = para_sceptre($ref,$valori,$tipito);
                                 impr_debug(__LINE__.' Scep $valori',$valori);  
	                    };
                            $dentro .= "$valori,";
                       };
                       $dentro =~ s/\,$//;
                   };
		   $valor = "$func($dentro)";
		   impr_debug(__LINE__.' Scep $valor',$valor);
 		   if (not $ref->{definicionFUNCIONES}->{$func}) {
                       while ($expr_usadas{"X$numx"}) {$numx ++};
		       $valor = "X$numx($valor)"; $numx ++;
                   };   
              } elsif ($tipo =~ /[avi]/i) {
	      } else {
                  error_progr($ref,__LINE__.' Scep $tipo'
                   . "tipo $tipo inesperado en sceptrear_expr");
               
              }; #agotados los tipos no 'n' ni 'p'
          }; #agotados todos los tipos
          #impr_dat_que($key,$que,__LINE__.' Scep ',$ref,'sc');
          #ya no importa no actualizar $refarg
          $ref->{$que}->{$key} = "$valor$coment";
          impr_dat_que($key,$que,__LINE__.' Scep',$ref,'scf');
      };#foreach $key    
  };#foreach $que
  comfin('finS sceptrear_expr',['DATOS','PARAMETROS','INICIALES','PARBORR']
          ,$ref,'impr');
}#sceptrear_expr
#----------------------------------------------------------------------------
sub imprimir_fortran{
  my ($todo,$coment) = @_;
  if ($coment) {$coment= ';'} else {$coment =''}; 
  my $nooperparcoma = '[^\(\)\+\-\*\/\,\s]';
  my $operparcoma = '[\(\)\+\-\*\/\,\s]';
  # por la limitación de renglon de fortran
  # no hay garantia de que quede bonito si justo 
  # pesca un numero con muchos digitos, pero Sceptre
  # lo entendera bien
  #impr_debug(__LINE__.' Scep imprimir_fortran $todo',"$todo");
  while (length($todo) > 60) {
      $todo =~ s/^(.{1,59}$nooperparcoma*$operparcoma*)//; 
      my $propu = "$1";
      $propu =~ s/^(.{1,65})//;
      my $ya = $1;
      $todo  = $propu . $todo;
      print SALIDA "$coment$ya\n";
  };
  print SALIDA "$coment$todo\n" if $todo;
}#imprimir_fortran
#----------------------------------------------------------------------------
sub imprs_lis_obj_sceptre{  
    comfin('comS imprs_lis_obj_sceptre',@_); 
    my ($refcircuito,$clase, $archguardar, $archguardarcongnus) = @_;
    sceptrear_expr($refcircuito) if  $clase eq 'circuito';
    my $no_outputs = '';
    my $archv = $refcircuito->{CORTO};
    my $archvsindia = $archv; $archvsindia =~ s/\.dia$//; 
    open SALIDA, ">$archguardarcongnus.d" 
       or ($clase eq 'modelo' and return);  
       #para posibles modelos guardados por root
    if ($clase eq 'modelo') {
	print SALIDA "MODEL DESCRIPTION\n$refcircuito->{nombremod}\n";
    } else {
	print SALIDA "CIRCUIT DESCRIPTION\n";
    };
    my $propiosindia = $refcircuito->{PROPIO}; $propiosindia =~ s/\.dia$//; 
    print SALIDA 
"     Archivo $archguardar.d 
       producido por S I M U S O L: (simusol1.pl) para S C E P T R E 
       a partir del archivo-diagrama $refcircuito->{PROPIO} 
            de fecha:  ", 
	   scalar localtime((stat "$refcircuito->{CORTO}")[9]),"\n";
    print SALIDA "       con opción -todas $opt_hash{todas}\n"
          if $opt_hash{todas};
    if ($refcircuito->{USAARCHIVOS}) {
        my @lista = union_conjunto(@{$refcircuito->{USAARCHIVOS}});
        print SALIDA ";     y archivos: @lista\n"
             , ";           (Ver archivo $reffi{$archv}->{PROPIO}.caj)\n";
    };
    my $basearchv = $reffi{$archv}->{BASEARCH}; 
    my %deplantilla;
    #impr_debug(__LINE__.' Scep listaDATOS'
    #         , $refcircuito->{listaDATOS});
    foreach  my $nombreele (@{$refcircuito->{listaDATOS}}) {
       next unless defined $nombreele and $nombreele =~ /^[RLCJE]/;
       next unless defined $refcircuito->{cualobjele}->{$nombreele}; 
       my $obj = $refcircuito->{cualobjele}->{$nombreele}->[-1];
       my $planti = $plantillalista->[$obj];
       push @{$deplantilla{$planti}}, $nombreele;
    }; 
    my @lisplanti = keys  %deplantilla;
    @lisplanti = grep ($_ >= 5, @lisplanti);
    my %mensuni;
    if (defined $DEFIUNI) { # $DEFIUNI esta definido si hay elementos
        foreach my $planti (@lisplanti) {
            $mensuni{$planti} = '';
            defined $DEFIUNI->{$planti} and $mensuni{$planti} 
               = "; Unidades $DEFIUNI->{$planti}->{archivouni}\n"  
        }; 
    };
    if (@lisplanti == 1) {
        print SALIDA
        "; Plantilla Circuito $nombreplantilla->[$lisplanti[0]];" 
        ,  " todos los elementos\n"
        , $mensuni{$lisplanti[0]};
    } else { 
      foreach my $planti (@lisplanti) {
        my $textotodos = " Plantilla Circuito $nombreplantilla->[$planti]: ";
        if (@{$deplantilla{$planti}} >10) {
            $textotodos = scalar @{$deplantilla{$planti}} . ' elementos';
	} else {
            $textotodos .= join ', ',@{$deplantilla{$planti}};   
        };
        imprimir_fortran($textotodos,";");
        print SALIDA $mensuni{$planti};
      };
    };
    my $BASEARCH = $refcircuito->{BASEARCH};
    if ($refcircuito->{USAELE}) {
        foreach my $file (keys %{$refcircuito->{USAELE}}) {
           my ($basearche, $propio, $corto, $propiosindia, $cortosindia) 
                      = relativizar($file,$BASEARCH); 
           print SALIDA "; Elementos: ";
           print SALIDA "  $corto,\n;           de fecha ",
               scalar localtime((stat "$file")[9]),"\n";
        }; #foreach
    };
    if ($refcircuito->{USAMODELOS}) {
       #impr_debug(__LINE__.' Scep USAMODELOS '
       #       , $refcircuito->{USAMODELOS});
       foreach my $plancshape (keys %{$refcircuito->{USAMODELOS}}) {
         my @listamod 
             = sort keys %{$refcircuito->{USAMODELOS}->{$plancshape}};
         foreach my $modelito (@listamod) {#importa el orden
            my $refcircm  = $defimod->{$plancshape}->{$modelito};
            my $file = $refcircm->{CORTO};
            print SALIDA "; Modelo: ";
            print SALIDA  "$file, (" .
	          descripcion_icono($plancshape). ": $modelito )\n;", 
 "           de fecha ",  scalar localtime((stat "$file")[9]),"\n";
        };
      };
    };
    if ($clase eq 'modelo') {
        print SALIDA "\n; Archivo no simulable\n";
        print SALIDA ";   Uso de este modelo:\n;     ",
         " $refcircuito->{uso}\n";
        if ($refcircuito->{nodos}) {
            print SALIDA ";   Nodos exteriores de este modelo: "
		, " $refcircuito->{nodos}\n";
	} else {
            print SALIDA "; sin nodos exteriores\n";
        };    
        print SALIDA ";   Argumentos de salida:  @{$refcircuito->{salida}}\n"
	    if @{$refcircuito->{salida}};
    };
    print SALIDA "; ***** Hubo $avisosgrav problema(s) grave(s)\n"
                     if $avisosgrav;
    print SALIDA 
        "; ***** Hubo  $avisosnograv aviso(s) \"no grave(s)\" \n"
                     if $avisosnograv;
    print SALIDA 
       "; ***** Hubo $avisosnoseent cosa(s) que no se entendieron \n"
                     if $avisosnoseent;    

    print SALIDA 
        "; ***** Vea los mensajes en el archivo $propiosindia.lss1\n"
                     if $avisosgrav or $avisosnograv or $avisosnoseent;
    imprs_elementos($refcircuito,$clase);
    imprs_params_inics($refcircuito,$clase);
    imprs_outputs($refcircuito,$archv,$archvsindia) 
         if $clase eq 'circuito';
    #impr_debug(__LINE__ . ' Scep USAFUN',$refcircuito->{USAFUN});
    #impr_debug(__LINE__ . ' Scep USATAB',$refcircuito->{USATAB});
    my @lisUSAFUN = keys %{$refcircuito->{USAFUN}};
    my @lisUSATAB = keys %{$refcircuito->{USATAB}};
    if (@lisUSAFUN or @lisUSATAB) {
        print SALIDA "\nFUNCTIONS\n";
        imprs_funciones($refcircuito,0)  if @lisUSAFUN;   
        imprs_tablas($refcircuito,0) if @lisUSATAB;
    };   

 
  if ($clase eq 'modelo') {
       comfin('finS imprs_lis_obj_sceptre');   
       return;
  } else {
       imprs_controles_sceptre($refcircuito);
  };
  close SALIDA;
  comfin('finS imprs_lis_obj_sceptre'); 
  return;
}#imprs_lis_obj_sceptre  
#-----------------------------------------------------------------------------
sub imprs_elementos{
  comfin('comS imprs_elementos',@_); 
  my ($refcircuito,$clase) = @_; 
  # foreach my $obj ( @{$refcircuito->{lisobjconectsnonodos}}) {
  # lo anterior pondria los elementos en el archivo .d en el orden de archivo
  # diagram }
  #    foreach my $nombreele (sort keys %{$refcircuito->{cualobjele}}) {
  # lo anterior ordenaria en orden alfabetico }
  #          my $nombreele = "$codlista->[$obj]$textolista->[$obj]"; 
  # asi aparecen en el orden que dio el usuario
  my $que = 'DATOS'; 
  #$que = 'DEFINICION' if $clase eq 'modelo'; 
  #imprhash(__LINE__.' Scep',%{$refcircuito->{$que}});
  #imprhash(__LINE__.' Scep',%{$refcircuito->{uni}});
  my $hay_sindato = 0;
  # Revisar: mejor que eleminar repetidos es no incorporar repetidos
  my (%norepetidos, @listaque);
  defined $refcircuito->{"lista$que"}
     and @listaque = @{$refcircuito->{"lista$que"}}
    or @listaque =();
  for (my $j = 0; $j< @listaque; $j++) {
      defined $norepetidos{$listaque[$j]} and delete $listaque[$j]
      or $norepetidos{$listaque[$j]} = 1 
  };
  return unless @listaque;
  #impr_debug(__LINE__.' Scep @listaque',\@listaque);
  #impr_debug(__LINE__.' Scep {uni}',Dumper $refcircuito->{uni});
  print SALIDA  "\nELEMENTS\n";
  foreach my $nombreele (@listaque) {
      next unless defined $nombreele;
      next if $nombreele =~ /^[TtZ]/;
      if ($nombreele =~ /^;/) {
          print SALIDA "$nombreele\n";
          next;
      };
      my $union = $refcircuito->{uni}->{$nombreele};
      my $nodocoment = '';
      if (defined $union) { 
      my $cuantos = ($union =~tr/\-//) +1; 
      if ($nombreele =~ /^[CELJR]/ and $cuantos != 2) {
          unless (
             $clase eq 'modelo' and $nombreele =~ /^C/  and $cuantos == 1) {
	       avgrav("Elemento que no tiene 2 conexiones;
                  $nombreele tiene $cuantos");
	   };
      }
 
      defined $union and do{
          if ($union=~ s/^([^;]+)(;.+)$/$1/) {$nodocoment = $2}; 
	  my $nodo = ($union =~ /^(.+)\-/);
          if (defined $nodo and $union eq "$nodo-$nodo") {
              if ($nombreele =~ /^E/) {
                  printf SALIDA "; lo siguiente no tiene sentido fisico\n";
	      };   
	      printf SALIDA "; el siguiente elemento cortocircuitado\n; ";
	  };
      };     
      };
      not defined $refcircuito->{cualobjele}->{$nombreele} 
          and $nombreele !~ /^M/ and next;
      my $sindato = 'sin dato';
      not defined $union and $union = $sindato;
      my $dato = $refcircuito->{DATOS}->{$nombreele};
      $dato =~ s/^LISTALIS\((.+)\)$/$1/i;
      not defined $dato and $dato = $sindato;
      $dato .= $nodocoment; #el comentario por dato lo puso sceptrear_expr
      "$union$dato" =~ /$sindato/ and do{print SALIDA ';'; $hay_sindato ++};
      my $renglon = sprintf "%6s,%13s = %1s", $nombreele,$union,$dato;
      imprimir_fortran($renglon);
   }; #for
   $hay_sindato and porparar1(185,$refcircuito,'Hay elementos sin datos '); 
   comfin('finS imprs_elementos'); 
}# imprs_elementos
#------------------------------------------------------------------------------
sub imprs_params_inics{
  my ($refcircuito, $clase) = @_;
  comfin('comS imprs_params_inics');
  #impr_datos(__LINE__.' Scep', ['PARAMETROS'], $refcircuito);
  #impr_debug(__LINE__.' Scep  VIEJOPAR '
  #            , Dumper $refcircuito->{VIEJOPARAMETROS});
  my @lisdefparams = ();
  #impr_debug(__LINE__.' Scep $clase',$clase);
  #impr_debug(__LINE__.' Scep $refcircuito->{listaPARAMETROS}}'
  #               ,Dumper $refcircuito->{listaPARAMETROS});
  impr_debug(__LINE__.' Scep $refcircuito->{USAPAR}}'
                 ,Dumper $refcircuito->{USAPAR});
  foreach (@{$refcircuito->{listaPARAMETROS}}) {
      push @lisdefparams, $_ if /^\s*;/;
      next unless $refcircuito->{USAPAR}->{$_};
      push @lisdefparams, "$_ = $refcircuito->{PARAMETROS}->{$_}"; 
  };    
  @lisdefparams = union_conorden (@lisdefparams);
  impr_debug(__LINE__.' Scep @lisdefparams',Dumper \@lisdefparams);
  my $inics = '';
  foreach (@{$refcircuito->{listaINICIALES}}) {
      if (/^;/) {
          $inics .= "$_\n";next
      };
      my $valor = $refcircuito->{INICIALES}->{$_};
      my $tipvalor = $refcircuito->{TIPINICIALES}->{$_};
      do {avnograv("No se consigue un valor numérico inicial para $_"); next}
               if not defined $valor or not defined $tipvalor; 
      if (/^P/ and $tipvalor eq 'n'
          and $refcircuito->{PARAMETROS}->{"D$_"}) {
            push @lisdefparams, "$_ = $valor";
      } elsif (/^P/ or /^[VI]/) {
           $inics .= "$_ = $valor\n";
      } else {
          error_progr($refcircuito, 'simusol1.pl: imprs_params_inics, '
            . __LINE__);
      }      	    
  };#foreach
  my $archivo = $refcircuito->{archivo};
  if (scalar keys %{$refcircuito->{PARBORR}}) {
      print SALIDA
         "\n; Hay parámetros ya sustituidos; ver archivo $archivo.par\n";
  };
  if (@lisdefparams) {
      print SALIDA "\nDEFINED PARAMETERS\n";
      map (imprimir_fortran($_,''),@lisdefparams);
  };
  print SALIDA "\nINITIAL CONDITIONS\n$inics" if $inics;
}# imprs_params_inics
#------------------------------------------------------------------------------
sub imprs_outputs{
  my ($refcircuito,$archv,$archvsindia) = @_;
  my $outputssceptre = "\n";
  if (defined $refcircuito->{lisoutputssceptre}) {
      my @lisouts = @{$refcircuito->{lisoutputssceptre}};
      shift @lisouts;
      if (@lisouts == 0) {
          avgrav("No llegan pedidos de resultados al Sceptre");
          return;
      };
      print SALIDA "\nOUTPUTS\n";
      #impr_debug(__LINE__.' Scep ',\@lisouts);
      if (@{$refcircuito->{listacomeRESU}}) {   
          print SALIDA join ("\n", @{$refcircuito->{listacomeRESU}}),"\n";
          my $texto = $refcircuito->{parsenarchivo};
          if (defined $texto) { 
	      #impr_debug(__LINE__.' Scep ',$refcircuito->{parsenarchivo});
              open PARAMCONST, ">${archvsindia}.par";
              print PARAMCONST $texto;
              close PARAMCONST;
              print SALIDA ";    Ver parámetros constantes en 
;     ${archvsindia}.par\n";
              explic(
              "Los valores de los parámetros pedidos que son constantes,
               están en el archivo ${archvsindia}.par");
          };
      };
      $outputssceptre = join (',',  @lisouts) . "\n"; 
      $outputssceptre  =~ s/([^,]+,[^,]+,[^,]+,[^,]+,[^,]+),/$1\n/g;
      $outputssceptre  =~ s/\n\n$/\n/;
      print SALIDA $outputssceptre;
  };
}# imprs_outputs
#-----------------------------------------------------------------------------
sub imprs_funciones{
  comfin('comS imprs_funciones',@_);
  my $refcircuito = $_[0];
  #impr_debug(__LINE__.' Scep %hash_funciones_definidas '
  #           , Dumper \%hash_funciones_definidas);
  #impr_debug(__LINE__.' Scep definicionfunciones '
  #           , Dumper $refcircuito->{definicionFUNCIONES});
  #impr_debug(__LINE__.' Scep USAFUN',$refcircuito->{USAFUN});
  my @funcionesnousadas;
  foreach my $fu (sort keys %{$refcircuito->{USAFUN}}) {#imp. orden
      next if $fu =~ /^listalis/i; 
      my $archivo = $refcircuito->{archivoFUNCIONES}->{$fu};
      print SALIDA "; $fu definida en archivo $archivo\n"
          if defined $archivo;
      my $todo = $refcircuito->{definicionFUNCIONES}->{$fu};
      impr_debug(__LINE__.' Scep $todo',$todo) if $todo;
      #%acep_fun se refiere a funciones conocidas por FORTRAN
      defined $todo or $acep_fun{lc($fu)} or 
      do {if (-f "funciones.for" and 
	not system "grep -i 'FUNCTION\ *$fu\ *\(' funciones.for >/dev/null"){
 #             explic("Hay definición de $fu en funciones.for");
 #             print SALIDA ";  $fu definida en funciones.for\n";
              next; 
           } else {
	     my $agre = '';
             $agre = "(con ese nombre no podría)"  if ($fu !~ /^Q/i);      
             avnograv("Hay una función no está definida en el diagrama $agre 
             ni en el archivo funciones.for :     $fu;  
             debiera ser conocida por FORTRAN"); 
             next; 
           };
      }; 
      imprimir_fortran($todo,'');
      next if $fu =~ /^Q\d+P/;
  };#foreach
  my $coment = '';
  map (do{$coment .= "$_\n" if /^;/}, @{$refcircuito->{listaFUNCIONES}});
  print SALIDA $coment if $coment;
  comfin('finS imprs_funciones');
}# imprs_funciones
#-----------------------------------------------------------------------------
sub imprs_tablas{
  my ($refcirc,$numrerun) = @_; 
  my ($prifila,$ultfila);
  #impr_tablas(__LINE__.' Scep', $refcirc);
  my @tablas = sort keys %hash_tablas_definidas;
  foreach my $idtabla (@tablas) {
      print SALIDA "\n";  
      my $reftabla = $refcirc->{defiTABLAS}->{$idtabla}; 
      my $archivo = $reftabla->{archivoTABLAS}->{$idtabla};
      print SALIDA  "; TABLE $idtabla definida en archivo $archivo\n"
	  if $numrerun == 0 and defined $archivo; #no esta para principal
      print SALIDA "TABLE $idtabla\n";
      next if $numrerun >= @{$reftabla->{priTABLAS}->{$idtabla}} ;
      $prifila = $reftabla->{priTABLAS}->{$idtabla}->[$numrerun]; 
      $ultfila = $reftabla->{ultTABLAS}->{$idtabla}->[$numrerun];
      my ($abscisas,$ordenadas)= 
          ($reftabla->{absTABLAS}->{$idtabla},
           $reftabla->{ordTABLAS}->{$idtabla});
      for (my $ifila = $prifila; $ifila <= $ultfila; $ifila ++) {
           print SALIDA  "$abscisas->[$ifila],$ordenadas->[$ifila]\n"; 
      };
      print SALIDA join ("\n"
         ,@{$reftabla->{comTABLAS}->{$idtabla}}),"\n"
		   if defined $reftabla->{comTABLAS}->{$idtabla};
  }; #foreach
}#imprs_tablas
#-----------------------------------------------------------------------------
sub imprs_controles_sceptre{
  comfin('comS imprs_controles_sceptre', @_);
  my $refcircuito = $_[0];
  #impr_debug(__LINE__.' Scep rerun',Dumper $refcircuito->{rerun});
  #impr_debug(__LINE__.' Scep START',$refcircuito->{'START TIME'});
  #impr_debug(__LINE__.' Scep STOP',$refcircuito->{'STOP TIME'});
  my %controles = ('X PLOT DIMENSION' => '0', 
     'INTEGRATION ROUTINE'=> 'TRAP');
  map ($controles{$_} = $refcircuito->{CONTROLES}->{$_},
        keys %{$refcircuito->{CONTROLES}});  
  my @controleskeys = union_conorden( 
     'X PLOT DIMENSION', 'START TIME', 'STOP TIME','INTEGRATION ROUTINE'
      ,@{$refcircuito->{listaCONTROLES}});
  $controles{'START TIME'} = $refcircuito->{'START TIME'}->{lista}->[0] . 
                            "   ; $refcircuito->{'START TIME'}->{tiempoorig}";
  $controles{'STOP TIME'} = $refcircuito->{'STOP TIME'}->{lista}->[0] .
                            "   ; $refcircuito->{'STOP TIME'}->{tiempoorig}"; 
  #impr_debug(__LINE__.' Scep controles', \%controles);
  # si no se pone el renglon X PLOT DIMENSION, o se da un valor no nulo
  # hay una pausa luego de la ejecucion de la traduccion de sceptre
  # y si no se escribe go no se produce el archivo xxx.dirac
  print SALIDA "\nRUN CONTROLS\n";
  foreach (@controleskeys) {
      #next if $_ eq 'START TIME' or $_ eq 'STOP TIME';
      print SALIDA $_;
      if (not defined $controles{$_}  or $controles{$_} eq 'aaaaaaaa') {
          print SALIDA "\n";
      } else {
           print SALIDA " = $controles{$_}\n";        
      };
  };
  if ($refcircuito->{nrerun}) {
      imprs_rerun($refcircuito);
  };
  print SALIDA "END\n";
  comfin('finS imprs_controles_sceptre');
}#imprs_controles_sceptre
#------------------------------------------------------------------------------
sub imprs_rerun{
  comfin('comS imprs_rerun', @_);
  my $ref = $_[0];
  my $rerun = $ref->{rerun};
  #impr_debug(__LINE__.' Scep  $ref->{rerun}', Dumper $ref->{rerun});
  #impr_debug(__LINE__.' Scep $rerun', Dumper $rerun);
  #impr_debug(__LINE__." Scep  $ref->{rerun}", Dumper $ref->{rerun});
  #impr_debug(__LINE__." Scep $rerun", Dumper $rerun);
  my $cuantos = $ref->{nrerun}; my $texto = '';
  if (defined $ref->{CONTROLES}->{'RERUN DESCRIPTION'}) {
      my @lista = ($ref->{'START TIME'}->{lista}->[0]
                            , @{$ref->{'STOP TIME'}->{lista}});
      for (my $numrerun = 1; $numrerun < $cuantos -1 ; $numrerun ++) {
           print SALIDA "RERUN DESCRIPTION\n";
           print SALIDA "FUNCTIONS\n";
           print SALIDA $texto; $texto ='';
           imprs_tablas($ref, $numrerun);
           print SALIDA "RUN CONTROLS\nSTART TIME = $lista[$numrerun]\n";
           print SALIDA "STOP TIME = $lista[$numrerun+1]\n"; 
      };
  } else {
      foreach my $que (keys %$rerun) {
          next unless scalar keys %{$rerun->{$que}} >0;
          if ($que eq 'INICIALES') {$texto .= "INITIAL CONDITIONS";
          } elsif ($que eq 'PARAMETROS') {$texto .= "DEFINED PARAMETERS";
          } elsif ($que eq 'CONTROLES') {$texto.= "RUN CONTROLS";  
          };          
          foreach my $key (keys %{$rerun->{$que}}) {
              my @lista = @{$rerun->{$que}->{$key}}; 
              #impr_debug(__LINE__." Scep key ...$key...",\@lista);
              my $cuan = $cuantos - @lista;
              my $master = shift @lista;
              $texto .= "\n$key = " . join ',', @lista;
              $texto .= ",$master" x  $cuan;
              #lo anterior  es necesario; 
              #si Sceptre no cuenta la misma cantidad de variaciones, hace lio
              $texto .= "\n";
          };
      };
      if ($texto) {
          print SALIDA "RERUN DESCRIPTION (". ($cuantos - 1) . ")\n"
		   .$texto;
      } else {
          %$rerun = ();
          #impr_debug(__LINE__.' Scep $rerun', Dumper $rerun);
          #impr_debug(__LINE__.' Scep $ref->{rerun}', Dumper $ref->{rerun});
      };
  }; #if else 
  #impr_debug(__LINE__.' Scep rerun', Dumper $ref->{rerun});
  comfin('finS imprs_rerun');
}#imprs_rerun
# ---------------------------------------------------------------------------
sub imprs_archivo_mod{
  comfin('comS imprs_archivo_mod', @_); 
  my ($ref) = $_[0];
  map(cargar_datos($ref,'PARAMETROS',$_,$_,'g','',0
              ,__LINE__.' Scep imprs_arch_mod')
      ,@{$ref->{listaarg}});
  my $coderr = desplegar_ele($ref,'modelo');#para impr...mod
  $coderr and return $coderr;
  completar_nodos($ref);# para mod
  temperaturas($ref); #para imprimir mod
  interpretar_values_termico(['DATOS','PARAMETROS'],$ref);#para impr...mod 
  tratar_funciones($ref);#para imprimir modelos
  #impr_debug(__LINE__.' Scep USAFUN', Dumper $ref->{USAFUN});
  realizar_ajustes($ref,'modelo');
  parar1(66,0) if $avisosgrav;
  $coderr = resumir_fun_par_tab_var_funx($ref,'modelo');
  $coderr and parar1($coderr,$ref,'');
  controlar_uso_def_parametros($ref);#en imprs_archivo_mod
  controlar_uso_funciones($ref);#en imprs_archivo_mod
  #impr_debug(__LINE__.' Scep USAFUN', $ref->{USAFUN});
  my $archguardar = $GlobalesSimusol::PROPIOA; $archguardar =~ s/\.dia$//;
  my $archguardarcongnus = $GlobalesSimusol::CORTOA;
  $archguardarcongnus =~ s/\.dia$//;
  if ($opt_hash{todas}) {
      $archguardar .= "_$opt_hash{todas}";
      $archguardar =~ s/\s+/_/g;
      $archguardarcongnus .= "_$opt_hash{todas}"; 
      $archguardarcongnus =~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
  };
  imprs_lis_obj_sceptre($ref, 'modelo',$archguardar, $archguardarcongnus); 
  comfin('finS imprs_archivo_mod'); 
} #imprs_archivo_mod
# ---------------------------------------------------------------------------
1
